/*global require*/
require([
    'testsuite/qunit',
    'jquery',
    'de_epages/product/ui/topsellerwidget'
], function (QUnit, $) {

    'use strict';

    var data = {
            items: [
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/wb_1003111010/wb_1003111010_xs.jpg', 'count': 142, 'name': 'Pathfinder ZG', 'productId': '17161'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/vs_3202112018/vs_3202112018_xs.jpg', 'count': 140, 'name': 'Black Bear Gemini', 'productId': '17234'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/nf_1005104010/nf_1005104010_xs.jpg', 'count': 138, 'name': 'North Face Tadpole 23', 'productId': '17162'},
                {'thumbnail': 'NO_IMAGE', 'count': 136, 'name': 'Meindl Air Revolution 2.0', 'productId': '17214'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/md_49412090/md_49412090_xs.jpg', 'count': 134, 'name': 'Meindl RFS Tibet', 'productId': '17199'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/lt_0401107001/lt_0401107001_1_xs.jpg', 'count': 132, 'name': 'Leatherman Tool Survival', 'productId': '17154'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/js_3200705005/js_3200705005_xs.jpg', 'count': 130, 'name': 'Tatonka Vento', 'productId': '17233'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/ht_0801199030/ht_0801199030_xs.jpg', 'count': 128, 'name': 'Grangers Extreme Cleaner', 'productId': '17237'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/ht_0801099030/ht_0801099030_xs.jpg', 'count': 126, 'name': 'Grangers Extreme Waterproof', 'productId': '17236'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/ho_40407/ho_40407_croft_xs.jpg', 'count': 124, 'name': 'Jack Wolfskin Blizzard Jacket', 'productId': '17187'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/ho_1112105010/ho_1112105010_xs.jpg', 'count': 122, 'name': 'Jack Wolfskin Flexibility RT', 'productId': '17159'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/hm_0100401001/hm_0100401001_xs.jpg', 'count': 120, 'name': 'Mag-Lite Mini', 'productId': '17153'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/er_7142303001/er_7142303001_xs.jpg', 'count': 118, 'name': 'Edelrid Black Bear Rope', 'productId': '17158'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/eg_1000111010/eg_1000111010_xs.jpg', 'count': 116, 'name': 'Eureka El Capitan IV', 'productId': '17160'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/de_3206199010/de_3206199010_xs.jpg', 'count': 114, 'name': 'Deuter Teddy Bear', 'productId': '17235'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/de_3203104010/de_3203104010_xs.jpg', 'count': 112, 'name': 'Deuter Kangaroo', 'productId': '17232'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/de_3201212002/de_3201212002_xs.jpg', 'count': 110, 'name': 'Deuter Hydro 2.0', 'productId': '17231'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/cg_0101104470/cg_0101104470_xs.jpg', 'count': 108, 'name': 'Camping AZ CV470 valve Gas canister', 'productId': '17157'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/cg_0101004270/cg_0101004270_xs.jpg', 'count': 106, 'name': 'Camping AZ CV270 valve gas canister', 'productId': '17156'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/cg_0100504001/cg_0100504001_xs.jpg', 'count': 104, 'name': 'Campingaz Twister 270', 'productId': '17155'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/be_40402/be_40402_red_xs.jpg', 'count': 102, 'name': 'Berghaus Paclite Jacket - Women', 'productId': '17175'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/be_40401/be_40401_blue_xs.jpg', 'count': 100, 'name': 'Berghaus Paclite Jacket - Men', 'productId': '17163'}
            ],
            viewAction: 'MBO-ViewGeneral',
            bundleThumbnail: '/WebRoot/Store/Shops/DemoShop/BO/icons/list_ico_s_bundleproducts.png',
            noImageThumbnail: '/WebRoot/StoreTypes/6.16.2/Store/BO/icons/ico_m_product.png'
        },
        dataFour = {
            items: [
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/wb_1003111010/wb_1003111010_xs.jpg', 'count': 142, 'name': 'Pathfinder ZG', 'productId': '17161'},
                {'thumbnail': 'BUNDLED_PRODUCT_IMAGE', 'count': 140, 'name': 'Black Bear Gemini', 'productId': '17234'},
                {'thumbnail': '/WebRoot/Store/Shops/DemoShop/Products/nf_1005104010/nf_1005104010_xs.jpg', 'count': 138, 'name': 'North Face Tadpole 23', 'productId': '17162'}
            ],
            viewAction: 'MBO-ViewGeneral',
            bundleThumbnail: '/WebRoot/Store/Shops/DemoShop/BO/icons/list_ico_s_bundleproducts.png',
            noImageThumbnail: '/WebRoot/StoreTypes/6.16.2/Store/BO/icons/ico_m_product.png'
        };

    QUnit.module('de_epages/product/ui/topsellerwidget', {
        setup: function () {
            $('<div class="dashboardCommunity ep-TopSellerWidget ep-js" data-js=".productUiTopSellerWidget()" /div>').appendTo('#qunit-fixture');
        }
    });

    QUnit.test('widget.methods', function () {
        $.each(['_create', '_render', '_openDialog', 'destroy'], function (i, method) {
            QUnit.equal(
                $.isFunction($.ui.productUiTopSellerWidget.prototype[method]),
                true,
                method + 'is a method of top seller widget'
            );
        });
    });

    QUnit.test('widget.insert', function () {
        var widget = $('div.ep-TopSellerWidget'),
            table,
            tbody;

        widget.productUiTopSellerWidget(data);

        // we want exactly one table
        table = widget.find('table');
        QUnit.equal(table.length, 1, 'should show one table');

        // with three rows for the products and one row for the more button
        tbody = table.find('tbody');

        QUnit.equal(
            tbody.find('tr').length,
            3,
            'should show a table with three product rows'
        );

        QUnit.equal(
            widget.find('div.more-link a').length,
            1,
            'should show a link to display more items'
        );
    });

    QUnit.test('widget.open-dialog', function () {
        var widget = $('div.ep-TopSellerWidget'),
            dialog,
            dialogContent,
            firstProduct,
            fourthProduct,
            firstTable,
            secondTable,
            thirdTable;

        widget.productUiTopSellerWidget(data);

        // open the dialog
        widget.find('div.more-link').trigger('click');

        // we expect to have exactly one dialog now
        dialog = $('body > div.ui-dialog');
        QUnit.equal(dialog.length, 1, 'should show one dialog');

        // the dialog should have a width of 1245px
        QUnit.equal(
            dialog.css('width'),
            '1245px',
            'should have a width of 1245spx'
        );

        dialogContent = dialog.find('div.ui-dialog-content');

        // the dialog should contain three tables
        QUnit.equal(
            dialogContent.find('td > table').length,
            3,
            'should show three tables in the dialog'
        );

        // with 10, 10 and 2 rows
        firstTable = dialogContent.find('table').eq(1);
        QUnit.equal(
            firstTable.find('tr').not('.topseller-widget-header').length,
            10,
            'should show 10 rows in the first table'
        );

        // with 10, 10 and 2 rows
        secondTable = dialogContent.find('table').eq(2);
        QUnit.equal(
            secondTable.find('tr').not('.topseller-widget-header').length,
            10,
            'should show 10 rows in the second table'
        );

        // with 10, 10 and 2 rows
        thirdTable = dialogContent.find('table').eq(3);
        QUnit.equal(
            thirdTable.find('tr').not('.topseller-widget-header').length,
            2,
            'should show 2 rows in the third table'
        );

        // the first product row should have the expected content
        firstProduct = firstTable.find('tr').eq(1);

        QUnit.equal(
            firstProduct.find('td').eq(0).find('img').attr('src'),
            '/WebRoot/Store/Shops/DemoShop/Products/wb_1003111010/wb_1003111010_xs.jpg',
            'should set the "src" attribute of the first cell of the first row to the image source of the first product'
        );

        QUnit.equal(
            firstProduct.find('td').eq(1).text(),
            'Pathfinder ZG',
            'should set the content of the second cell of the first row to the description of the first product'
        );

        QUnit.equal(
            firstProduct.find('td').eq(2).text(),
            '142',
            'should set the content of the third cell of the first row to the number of sold items of the first product'
        );

        // the first product row should have the expected content
        fourthProduct = firstTable.find('tr').eq(4);

        QUnit.equal(
            fourthProduct.find('td').eq(0).find('img').attr('src'),
            '/WebRoot/StoreTypes/6.16.2/Store/BO/icons/ico_m_product.png',
            'should set the "src" attribute of the first cell of the fourth row to the standard product image'
        );

        // close the dialog
        dialog.find('div.ui-dialog-titlebar button').trigger('click');

        // we expect the dialog to be hidden now
        dialog = $('body > div.ui-dialog');
        QUnit.equal(dialog.css('display'), 'none', 'should hide the dialog');

        widget.productUiTopSellerWidget('destroy');
    });

    QUnit.test('widget.exactly-four-elements', function () {
        var widget = $('div.ep-TopSellerWidget'),
            tbody;

        widget.productUiTopSellerWidget(dataFour);

        // with three rows for the products and none row for the more button
        tbody = widget.find('table tbody');
        QUnit.equal(
            tbody.find('tr').not('.topseller-widget-header').length,
            3,
            'should show a table with three product rows'
        );

        QUnit.equal(
            widget.find('div.more-link a').length,
            0,
            'shouldn\'t show a link to display more items'
        );
    });

    QUnit.test('widget.bundle-products', function () {
        var widget = $('div.ep-TopSellerWidget'),
            tbody;

        widget.productUiTopSellerWidget(dataFour);
        QUnit.equal(
            widget.find('table tbody tr').eq(1).find('td').first().find('img').attr('src'),
            '/WebRoot/Store/Shops/DemoShop/BO/icons/list_ico_s_bundleproducts.png',
            'should display the thumbnail for bundle products for the second product'
        );

        widget.productUiTopSellerWidget('destroy');

        QUnit.equal(
            widget.data('uiProductUiTopSellerWidget'),
            undefined,
            'should remove data attribute uiProductUiTopSellerWidget after call of destroy method'
        );

        QUnit.equal(
            widget.children().length,
            0,
            'should empty widget elementP after call of destroy method'
        );
    });
});
