/*globals define*/
define(['testsuite/qunit', 'testsuite/qunit-fixture!ep/ui/thumbbox-test', 'jquery', 'ep/ui/thumbbox', '$ready!'], function (QUnit, fixture, $, ep) {

    QUnit.module("ep/ui/thumbbox", {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.asyncTest("ep/ui/thumbbox", function () {

        var t,

            thumb01 = $('#thumbbox01')
                .uiThumbbox({
                    images  : '#images img',
                    width   : 200,
                    height  : 200,
                    action  : "slides",
                    view    : "list"
                }),

            thumb02 = $('#thumbbox02')
                .uiThumbbox({
                    images  : '#images img',
                    width   : 150,
                    height  : 150,
                    view    : "fisheye"
                }),

            thumb03 = $('#thumbbox03')
                .uiThumbbox({
                    images  : '#images img',
                    view    : "slide"
                }),

            imgData = ep.ui.imgData('#images img')
                .on('slides', function () {
                    t = this.current();
                });

        setTimeout(function () {

            QUnit.equal(
                thumb01.find('img').length,
                8,
                "ep('#thumbbox01 img').length"
            );

            QUnit.equal(
                thumb02.find('img').length,
                8,
                "ep('#thumbbox02 img').length"
            );

            QUnit.equal(
                thumb03.find('img').length,
                8,
                "ep('#thumbbox03 img').length"
            );

            QUnit.equal(
                imgData.current().desc,
                "Bild 1",
                "ep.ui.imgData('#images img').current().desc"
            );

            QUnit.equal(
                imgData.current().src,
                "../ep/ui/thumbbox-test-image1.jpg",
                "ep.ui.imgData('#images img').current().src"
            );

            thumb01.find('img:eq(3)').trigger('click');

            QUnit.equal(
                imgData.current().src,
                "../ep/ui/thumbbox-test-image2.jpg",
                "ep.ui.imgData('#images img').current().src"
            );

            QUnit.equal(
                imgData.current().desc,
                "Bild 4",
                "ep.ui.imgData('#images img').current().desc"
            );

            QUnit.equal(
                t.src,
                "../ep/ui/thumbbox-test-image2.jpg",
                ".click( ... this.current().src ... )"
            );

            QUnit.equal(
                t.desc,
                "Bild 4",
                ".click( ... this.current().desc ... )"
            );

            QUnit.equal(
                thumb03.find('ul').css('left') === 'auto' || thumb03.find('ul').css('left') === '0px',
                1,
                "ep('#thumbbox03 img').children().css('left')"
            );

            thumb03
                .children()
                .trigger({
                    type: 'mousemove',
                    pageX:  500
                });

            setTimeout(function () {

                QUnit.equal(
                    parseInt(thumb03.find('ul').css('left'), 10) < -100,
                    true,
                    "ep('#thumbbox03 img').children().css('left') < '-100px'"
                );

                thumb03
                    .children()
                    .trigger({
                        type: 'mousemove',
                        pageX: thumb03.offset().left + 50
                    });

                setTimeout(function () {

                    QUnit.equal(
                        parseInt(thumb03.find('ul').css('left'), 10) > -50,
                        true,
                        "ep('#thumbbox03 img').children().css('left') > '-50px'"
                    );

                    QUnit.start();

                }, 300);

            }, 300);

        }, 500);

    });
});